/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreValuelistJsonbNaturalRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.JSONB;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreValuelistJsonbNatural extends TableImpl<VCoreValuelistJsonbNaturalRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of
     * <code>common_dd.v_core_valuelist_jsonb_natural</code>
     */
    public static final VCoreValuelistJsonbNatural V_CORE_VALUELIST_JSONB_NATURAL = new VCoreValuelistJsonbNatural();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreValuelistJsonbNaturalRecord> getRecordType() {
        return VCoreValuelistJsonbNaturalRecord.class;
    }

    /**
     * The column
     * <code>common_dd.v_core_valuelist_jsonb_natural.fk_valuelist</code>.
     */
    public final TableField<VCoreValuelistJsonbNaturalRecord, Integer> FK_VALUELIST = createField(DSL.name("fk_valuelist"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_core_valuelist_jsonb_natural.jsonb_object_agg</code>.
     */
    public final TableField<VCoreValuelistJsonbNaturalRecord, JSONB> JSONB_OBJECT_AGG = createField(DSL.name("jsonb_object_agg"), SQLDataType.JSONB, this, "");

    private VCoreValuelistJsonbNatural(Name alias, Table<VCoreValuelistJsonbNaturalRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreValuelistJsonbNatural(Name alias, Table<VCoreValuelistJsonbNaturalRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_valuelist_jsonb_natural" as  WITH x(fk_valuelist, varvalue, value_order, isocode, value) AS (
                SELECT vl.valuelist,
                   v.varvalue,
                   v.value_order,
                   COALESCE((l.isocode)::text, 'all'::text) AS "coalesce",
                       CASE
                           WHEN (l.isocode IS NULL) THEN jsonb_build_object('?', vp.param_key)
                           ELSE jsonb_build_object(l.category, l.value)
                       END AS jsonb_build_object
                  FROM (((common_dd.t_core_valuelist vl
                    LEFT JOIN common_dd.t_core_value v ON ((v.fk_value_valuelist = vl.valuelist)))
                    LEFT JOIN common_dd.t_core_valueparam vp ON ((vp.fk_valueparam_value = v.pk_core_value)))
                    LEFT JOIN common_dd.t_core_translation l ON ((l.fk_trans_key = vp.param_key)))
                 WHERE (v.varvalue IS NOT NULL)
               ), y(fk_valuelist, varvalue, value_order, value) AS (
                SELECT x.fk_valuelist,
                   x.varvalue,
                   x.value_order,
                       CASE
                           WHEN (x.isocode IS NULL) THEN jsonb_build_object('?', x.value)
                           ELSE jsonb_object_agg(x.isocode, x.value)
                       END AS jsonb_object_agg
                  FROM x
                 GROUP BY x.fk_valuelist, x.varvalue, x.value_order, x.value, x.isocode
                 ORDER BY x.fk_valuelist, x.varvalue, x.value_order
               )
        SELECT fk_valuelist,
           jsonb_object_agg((varvalue)::text, value) AS jsonb_object_agg
          FROM y
         GROUP BY fk_valuelist;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_valuelist_jsonb_natural</code>
     * table reference
     */
    public VCoreValuelistJsonbNatural(String alias) {
        this(DSL.name(alias), V_CORE_VALUELIST_JSONB_NATURAL);
    }

    /**
     * Create an aliased <code>common_dd.v_core_valuelist_jsonb_natural</code>
     * table reference
     */
    public VCoreValuelistJsonbNatural(Name alias) {
        this(alias, V_CORE_VALUELIST_JSONB_NATURAL);
    }

    /**
     * Create a <code>common_dd.v_core_valuelist_jsonb_natural</code> table
     * reference
     */
    public VCoreValuelistJsonbNatural() {
        this(DSL.name("v_core_valuelist_jsonb_natural"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreValuelistJsonbNatural as(String alias) {
        return new VCoreValuelistJsonbNatural(DSL.name(alias), this);
    }

    @Override
    public VCoreValuelistJsonbNatural as(Name alias) {
        return new VCoreValuelistJsonbNatural(alias, this);
    }

    @Override
    public VCoreValuelistJsonbNatural as(Table<?> alias) {
        return new VCoreValuelistJsonbNatural(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistJsonbNatural rename(String name) {
        return new VCoreValuelistJsonbNatural(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistJsonbNatural rename(Name name) {
        return new VCoreValuelistJsonbNatural(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistJsonbNatural rename(Table<?> name) {
        return new VCoreValuelistJsonbNatural(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistJsonbNatural where(Condition condition) {
        return new VCoreValuelistJsonbNatural(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistJsonbNatural where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistJsonbNatural where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistJsonbNatural where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistJsonbNatural where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistJsonbNatural where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistJsonbNatural where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistJsonbNatural where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistJsonbNatural whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistJsonbNatural whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
